package cn.iocoder.yudao.module.member.service.activitytable;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.activityrestaurant.vo.ActivityRestaurantSaveReqVO;
import cn.iocoder.yudao.module.member.controller.admin.activitytable.vo.*;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppCheckVO;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppUnbindVO;
import cn.iocoder.yudao.module.member.dal.dataobject.activitytable.ActivityTableDO;
import org.springframework.web.bind.annotation.RequestBody;

import javax.validation.Valid;
import java.time.LocalDate;
import java.util.List;
import java.util.Map;

/**
 * 活动用餐桌子 Service 接口
 *
 * @author 我是秦俊旗
 */
public interface ActivityTableService {

    /**
     * 创建活动用餐桌子
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createActivityTable(@Valid ActivityTableSaveReqVO createReqVO);

    /**
     * 更新活动用餐桌子
     *
     * @param updateReqVO 更新信息
     */
    void updateActivityTable(@Valid ActivityTableSaveReqVO updateReqVO);

    /**
     * 删除活动用餐桌子
     *
     * @param id 编号
     */
    void deleteActivityTable(Long id);

    /**
     * 获得活动用餐桌子
     *
     * @param id 编号
     * @return 活动用餐桌子
     */
    ActivityTableDO getActivityTable(Long id);

    /**
     * 获得活动用餐桌子分页
     *
     * @param pageReqVO 分页查询
     * @return 活动用餐桌子分页
     */
    PageResult<ActivityTableDO> getActivityTablePage(ActivityTablePageReqVO pageReqVO);

    Map<Long, ActivityTableCountVO> countByActivityIds(List<Long> activityIds);

    void createByRestaurant(ActivityRestaurantSaveReqVO activityRestaurantSaveReqVO);

    void deleteByActivityId(Long activityId);

    List<ActivityTableDO> getListByActivityIdAndTime(Long activityId,String time);

    Boolean userTableCheck(AppCheckVO vo);

    Boolean userTableUnbind(AppUnbindVO vo);

    List<ActivityTableDO> getListByActivityId(Long activityId);

    List<ActivityTableDO> getListByActivityIdAndTimeAndUserId(Long activityId, LocalDate time, Long userId);


    Long createActivityTableFalse( ActivityTableCreateVO createReqVO);

    Boolean updateTime(@Valid @RequestBody UpdateTimeVO updateTimeVO);
}